/*
 * RAMFILE - fopen/fseek/ftell/fgetc/fread/fclose replacement to read
 *           from memory buffer.
 * (c)1998 Jari Komppa
 */
#ifdef __cplusplus
extern "C" {
#endif
#ifndef RAMFILE_H_INCLUDED
#define RAMFILE_H_INCLUDED

typedef struct ramfilestruct {
  char * buffer;
  int offset;
  int length;
  int _flag;
} RAMFILE;

extern RAMFILE * RAMfopen(char * buffer, int length);
extern RAMFILE * RAMfopencfl(char * fname);
extern int RAMfseek(RAMFILE * t, int displacement, int mode);
extern int RAMftell(RAMFILE * t);
extern int RAMfgetc(RAMFILE * t);
extern int RAMfread(void * buf, int size, int count, RAMFILE * t);
extern int RAMfclose(RAMFILE * t);
extern int RAMfclose_nofree(RAMFILE * t);
#endif

#ifndef RAMFILIZE
#define RAMFILIZE
#define FILE RAMFILE
#define fseek RAMfseek
#define ftell RAMftell
#define fgetc RAMfgetc
#define fread RAMfread
#define fclose RAMfclose
#define fopen(a,b) RAMfopencfl(a)
#endif
#ifdef __cplusplus
}
#endif
