#define WIN32_LEAN_AND_MEAN		
#include <windows.h> // windows stuff
#include <stdio.h>   // standard IO
#include <stdlib.h>  // standard C lib
#include <ddraw.h>   // DirectDraw
#include <d3d.h>     // Direct3D
#include <d3dx.h>    // Direct3DX
#include "pcxload.h"

extern LPDIRECT3DDEVICE7 d3dd;

LPDIRECTDRAWSURFACE7 loadpcxtx(char * fname) {
  LPDIRECTDRAWSURFACE7 tx;
  char * pcxdata=loadpcx(fname);
  char * pcxpal=loadpcxpal(fname);
  int duh=0,flg=0,wid=256,ht=256;
  getpcxinfo(fname,(int*)&wid,(int*)&ht);
  D3DX_SURFACEFORMAT sfmt;  
  
  int * pp=(int*)malloc(wid*ht*4);
  for (int i=0,c=0,p=0;i<ht;i++,p+=wid)
    for (int j=0;j<wid;j++,c++) {
      int col=((*(pcxpal+(*(pcxdata+c)&0xff)*3+0)&0xff)<<16)+
              ((*(pcxpal+(*(pcxdata+c)&0xff)*3+1)&0xff)<<8)+
              ((*(pcxpal+(*(pcxdata+c)&0xff)*3+2)&0xff)<<0);
      *(pp+p+j)=col;
    }
  
  free(pcxdata);
  free(pcxpal);
  RECT dr;
  dr.bottom=ht;
  dr.left=0;
  dr.right=wid;
  dr.top=0;
  sfmt=D3DX_SF_R8G8B8;//R5G6B5; 
  if (FAILED(D3DXCreateTexture(d3dd,(unsigned long*)&flg,(unsigned long*)&wid,(unsigned long*)&ht,&sfmt,NULL,&tx,(unsigned long*)&duh))) return NULL;  
  for (i=0;i<8;i++)
    if (FAILED(D3DXLoadTextureFromMemory(d3dd,tx,i,(void*)pp,NULL,D3DX_SF_X8R8G8B8,D3DX_DEFAULT,&dr,D3DX_FT_LINEAR))) return NULL;
  free(pp);
  return tx;
}

LPDIRECTDRAWSURFACE7 loadpcxtx(char * fname, char * fnamealpha) {
  LPDIRECTDRAWSURFACE7 tx;
  char * pcxdata=loadpcx(fname);
  char * pcxpal=loadpcxpal(fname);
  char * apcxdata=loadpcx(fnamealpha);
  char * apcxpal=loadpcxpal(fnamealpha);
  int duh=0,flg=0,wid=256,ht=256;
  getpcxinfo(fname,(int*)&wid,(int*)&ht);
  D3DX_SURFACEFORMAT sfmt;  
  
  int * pp=(int*)malloc(wid*ht*4);
  for (int i=0,c=0,p=0;i<ht;i++,p+=wid)
    for (int j=0;j<wid;j++,c++) {
      int col=((*(apcxpal+(*(apcxdata+c)&0xff)*3+0)&0xff)<<24)+ 
							((*(pcxpal+(*(pcxdata+c)&0xff)*3+0)&0xff)<<16)+
              ((*(pcxpal+(*(pcxdata+c)&0xff)*3+1)&0xff)<<8)+
              ((*(pcxpal+(*(pcxdata+c)&0xff)*3+2)&0xff)<<0);
      *(pp+p+j)=col;
    }
  
  free(pcxdata);
  free(pcxpal);
  free(apcxdata);
  free(apcxpal);
  RECT dr;
  dr.bottom=ht;
  dr.left=0;
  dr.right=wid;
  dr.top=0;
  sfmt=D3DX_SF_A8R8G8B8;//A4R4G4B4; 
  if (FAILED(D3DXCreateTexture(d3dd,(unsigned long*)&flg,(unsigned long*)&wid,(unsigned long*)&ht,&sfmt,NULL,&tx,(unsigned long*)&duh))) return NULL;  
  for (i=0;i<8;i++)
    if (FAILED(D3DXLoadTextureFromMemory(d3dd,tx,i,(void*)pp,NULL,D3DX_SF_A8R8G8B8,D3DX_DEFAULT,&dr,D3DX_FT_LINEAR))) return NULL;
  free(pp);
  return tx;
}

